### A free/open-source library for quantitative finance

Public Member Functions | Protected Attributes
StochasticProcessArray Class Reference
Stochastic processes

Array of correlated 1-D stochastic processes More...

`#include <ql/processes/stochasticprocessarray.hpp>`

Inheritance diagram for StochasticProcessArray:
[legend]

List of all members.

## Public Member Functions

| StochasticProcessArray (const std::vector< boost::shared_ptr< StochasticProcess1D > > &, const Matrix &correlation)
Size | size () const
| returns the number of dimensions of the stochastic process
Disposable< Array > | initialValues () const
| returns the initial values of the state variables
Disposable< Array > | drift (Time t, const Array &x) const
| returns the drift part of the equation, i.e.,
Disposable< Array > | expectation (Time t0, const Array &x0, Time dt) const
Disposable< Matrix > | diffusion (Time t, const Array &x) const
| returns the diffusion part of the equation, i.e.
Disposable< Matrix > | covariance (Time t0, const Array &x0, Time dt) const
Disposable< Matrix > | stdDeviation (Time t0, const Array &x0, Time dt) const
Disposable< Array > | apply (const Array &x0, const Array &dx) const
Disposable< Array > | evolve (Time t0, const Array &x0, Time dt, const Array &dw) const
Time | time (const Date &) const
const boost::shared_ptr < StochasticProcess1D > & | process (Size i) const
Disposable< Matrix > | correlation () const

## Protected Attributes

std::vector< boost::shared_ptr < StochasticProcess1D > > | processes_
Matrix | sqrtCorrelation_

## Detailed Description

Array of correlated 1-D stochastic processes

## Member Function Documentation

Disposable<Array> expectation | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const`[virtual]`

returns the expectation of the process after a time interval according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Matrix> covariance | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const`[virtual]`

returns the covariance of the process after a time interval according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Matrix> stdDeviation | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt
| ) |  | const`[virtual]`

returns the standard deviation of the process after a time interval according to the given discretization. This method can be overridden in derived classes which want to hard-code a particular discretization.

Reimplemented from StochasticProcess.

Disposable<Array> apply | ( | const Array & | x0,
|  | const Array & | dx
| ) |  | const`[virtual]`

applies a change to the asset value. By default, it returns .

Reimplemented from StochasticProcess.

Disposable<Array> evolve | ( | Time | t0,
|  | const Array & | x0,
|  | Time | dt,
|  | const Array & | dw
| ) |  | const`[virtual]`

returns the asset value after a time interval according to the given discretization. By default, it returns

where is the expectation and the standard deviation.

Reimplemented from StochasticProcess.

Time time | ( | const Date & |  | ) | const`[virtual]`

returns the time value corresponding to the given date in the reference system of the stochastic process.

Note:
  As a number of processes might not need this functionality, a default implementation is given which raises an exception.

Reimplemented from StochasticProcess.